<template>
  <div class="app-container">
    <div class="filter-container">
      <el-input v-model="query.title" :placeholder="$t('table.title')" style="width: 200px;" class="filter-item" @keyup.enter.native="handleFilter" />
      <el-button class="filter-item" type="primary" icon="el-icon-search" @click="handleFilter">
        {{ $t('table.search') }}
      </el-button>
    </div>
    <el-table v-loading="listLoading" :data="list" border fit highlight-current-row style="width: 100%">
      <el-table-column align="center" :label="$t('row.owner')">
        <template slot-scope="scope">
          <span>{{ scope.row.user }}</span>
        </template>
      </el-table-column>

      <el-table-column align="center" :label="$t('form.province')">
        <template slot-scope="scope">
          <span>{{ scope.row.province }}</span>
        </template>
      </el-table-column>

      <el-table-column align="center" :label="$t('form.city')">
        <template slot-scope="scope">
          <span>{{ scope.row.city }}</span>
        </template>
      </el-table-column>

      <el-table-column align="center" :label="$t('form.address')">
        <template slot-scope="scope">
          <span>{{ scope.row.address }}</span>
        </template>
      </el-table-column>

      <el-table-column align="center" :label="$t('form.region')">
        <template slot-scope="scope">
          <span>{{ scope.row.region }}</span>
        </template>
      </el-table-column>

      <el-table-column align="center" :label="$t('form.subscriptionNumber')">
        <template slot-scope="scope">
          <span>{{ scope.row.counter }}</span>
        </template>
      </el-table-column>

      <el-table-column align="center" :label="$t('form.qrcodes')">
        <template slot-scope="scope">
          <span>{{ scope.row.qr_code }}</span>
        </template>
      </el-table-column>

      <el-table-column align="center" :label="$t('form.rowColumn')">
        <template slot-scope="scope">
          <span>{{ scope.row.metadata }}</span>
        </template>
      </el-table-column>

    </el-table>

    <pagination v-show="total>0" :total="total" :page.sync="query.page" :limit.sync="query.limit" @pagination="getList" />
  </div>
</template>

<script>
import Pagination from '@/components/Pagination'; // Secondary package based on el-pagination
import Address from '@/api/address';
const addresResource = new Address('address');
import 'vue-select/src/scss/vue-select.scss';
// import i18n from '@/lang';

export default {
  name: 'AddressList',
  components: { Pagination },
  filters: {
    statusFilter(status) {
      const statusMap = {
        published: 'success',
        draft: 'info',
        deleted: 'danger',
      };
      return statusMap[status];
    },
  },
  data() {
    return {
      list: null,
      total: 0,
      request: {},
      listLoading: true,
      dialogFormVisible: false,
      dialogFormListVisible: false,
      transferAddress: false,
      query: {
        page: 1,
        limit: 15,
        title: '',
        role: '',
      },
      options: [],
    };
  },
  created() {
    this.getList();
  },
  methods: {
    async getList() {
      this.listLoading = true;
      const { result } = await addresResource.counters(this.query);
      this.list = result.rows;
      this.total = result.total;
      this.listLoading = false;
    },
    selectCounter(addressId, associateType) {
      this.request.addressId = addressId;
      this.request.associateType = associateType;
      this.$confirm(this.$i18n.t(`dialog.is` + associateType), this.$i18n.t(`dialog.confirm`), {
        confirmButtonText: this.$i18n.t(`dialog.confirm`),
        cancelButtonText: this.$i18n.t(`dialog.cancel`),
        type: 'warning',
      })
        .then(async() => {
          const result = await addresResource.selectCounter(this.request);
          if (result.success === true) {
            this.getList();
          }
        })
        .catch(err => {
          console.error(err);
        });
    },
    handleFilter() {
      this.query.page = 1;
      this.getList();
    },
    onSearch(search, loading) {
      fetch(
        '/api/searchUsers?q=' + search
      ).then(res => {
        res.json().then(json => (this.options = json.items));
        console.log(this.options);
        loading(false);
      });
    },
  },
};
</script>
